<template>
    <div>
        <TableHeader ref="TableHeaderRef">
            <template #select>
                <el-form-item label="工程名称">
                    <el-input v-model="tableStore.table.params.projectName" clearable></el-input>
                </el-form-item>
                <el-form-item label="所属地市">
                    <el-select v-model="tableStore.table.params.city" clearable placeholder="请选择所属地市">
                        <el-option
                            v-for="item in areaOptionList"
                            :key="item.id"
                            :label="item.name"
                            :value="item.name"
                        ></el-option>
                    </el-select>
                </el-form-item>
            </template>
            <template #operation>
                <!-- <el-button icon='el-icon-Download' type='primary'>导出</el-button> -->
            </template>
        </TableHeader>
        <Table ref="tableRef" />
    </div>

    <el-dialog
        title="干扰源用户详细信息"
        v-model="dialogVisible"
        width="65%"
        :append-to-body="true"
        :close-on-click-modal="false"
        draggable
    >
        <BpmUserReportDetail :id="interId" ref="detailsRef"></BpmUserReportDetail>
    </el-dialog>
</template>
<script setup lang="ts">
defineOptions({
    name: 'supervision/interferenceUserTable'
})
import { ref, onMounted, provide, nextTick } from 'vue'
import TableStore from '@/utils/tableStore'
import Table from '@/components/table/index.vue'
import TableHeader from '@/components/table/header/index.vue'
import { useDictData } from '@/stores/dictData'
import { getUserReportById } from '@/api/supervision-boot/userReport/form'
import BpmUserReportDetail from '../../components/undocumented/detail.vue'
const dictData = useDictData()
const areaOptionList = dictData.getBasicData('jibei_area')

const { push } = useRouter()
const TableHeaderRef = ref()
const tableStore = new TableStore({
    url: '/supervision-boot/userReport/getInterferenceUserPage',
    publicHeight: 65,
    method: 'POST',
    column: [
        { title: '序号', type: 'seq', width: 80 },
        { field: 'city', title: '所属地市', minWidth: 80 },
        { field: 'projectName', title: '工程名称', minWidth: 170 },
        {
            field: 'userType',
            title: '用户性质',
            minWidth: 150,
            formatter: (obj: any) => {
                const userType = obj.row.userType
                return getUserTypeName(userType)
            }
        },
        // { field: 'responsibleDepartment', title: '归口管理部门', minWidth: 130 },
        {
            field: 'userStatus',
            title: '用户状态',
            minWidth: 100,
            render: 'tag',
            custom: {
                0: 'primary',
                1: 'primary',
                2: 'success',
                3: 'warning'
            },
            replaceValue: {
                0: '可研',
                1: '建设',
                2: '运行',
                3: '退运'
            }
        },
        { field: 'substation', title: '变电站', minWidth: 100 },
        {
            title: '详细信息',
            minWidth: 100,
            render: 'buttons',
            buttons: [
                {
                    name: 'productSetting',
                    title: '详情',
                    type: 'primary',
                    icon: 'el-icon-EditPen',
                    render: 'basicButton',
                    click: row => {
                        open(row)
                    }
                }
            ]
        },

        {
            title: '操作',
            minWidth: 180,
            fixed: 'right',
            render: 'buttons',
            buttons: [
                {
                    name: 'productSetting',
                    title: '入网设计方案审查',
                    type: 'primary',
                    icon: 'el-icon-EditPen',
                    render: 'basicButton',
                    click: row => {
                        toFangAn(row, 0)
                    }
                },
                {
                    name: 'productSetting',
                    title: '治理工程验收',
                    type: 'primary',
                    icon: 'el-icon-EditPen',
                    render: 'basicButton',
                    click: row => {
                        toFangAn(row, 1)
                    }
                }
            ]
        }
    ],

    beforeSearchFun: () => {
        tableStore.table.params.orgNo = tableStore.table.params.deptIndex
        tableStore.table.params.relationUserName = tableStore.table.params.userName
    }
})
tableStore.table.params.city = ''
tableStore.table.params.projectName = ''
tableStore.table.params.loadType = ''
tableStore.table.params.userName = ''
tableStore.table.params.relationUserName = ''
tableStore.table.params.aisFileUpload = ''
const dialogVisible = ref(false)
const interId = ref()
provide('tableStore', tableStore)
onMounted(() => {
    tableStore.index()
})
const detailsRef = ref(null)
/** 打开弹窗 */
const open = async val => {
    interId.value = val.id
    dialogVisible.value = true
}

const needGovernance = ref()
/** 方案审查 */
const toFangAn = (row: any, typeNo: number) => {
    //查询详情拿到needGovernance
    /** 获得数据 */
    getUserReportById(row.id).then(res => {
        if (res.data.userType == '0' || res.data.userType == '1') {
            needGovernance.value = res.data.userReportProjectPO?.needGovernance
        } else if (
            res.data.userType == '2' ||
            res.data.userType == '3' ||
            res.data.userType == '4' ||
            res.data.userType == '5'
        ) {
            needGovernance.value = res.data.userReportSubstationPO?.needGovernance
        } else if (res.data.userType == '6') {
            needGovernance.value = res.data.userReportSensitivePO?.needGovernance
        }
        push({
            name: 'ProgramReview',
            query: {
                id: row.id,
                type: typeNo,
                needGovernance: needGovernance.value
            }
        })
    })
}

/**获取用户性质*/
const getUserTypeName = (userType: any) => {
    if (userType === 0) {
        return '新建电网工程'
    }
    if (userType === 1) {
        return '扩建电网工程'
    }
    if (userType === 2) {
        return '新建非线性负荷用户'
    }
    if (userType === 3) {
        return '扩建非线性负荷用户'
    }
    if (userType === 4) {
        return '新建新能源发电站'
    }
    if (userType === 5) {
        return '扩建新能源发电站'
    }
    if (userType === 6) {
        return '敏感及重要用户'
    }
    return '新建电网工程'
}
</script>
